# Uses of Class
org.apache.sysds.runtime.ooc.cache.BlockKey

Packages that use BlockKey
Package
Description
org.apache.sysds.runtime.instructions.ooc
org.apache.sysds.runtime.ooc.cache
org.apache.sysds.runtime.ooc.cache.io
org.apache.sysds.runtime.ooc.cache.legacy
org.apache.sysds.runtime.ooc.cache.packed

## Uses of BlockKey in org.apache.sysds.runtime.instructions.ooc

Methods in org.apache.sysds.runtime.instructions.ooc that return BlockKey
Modifier and Type
Method
Description
`BlockKey`
CachingStream.`peekCachedBlockKey(MatrixIndexes idx)`

## Uses of BlockKey in org.apache.sysds.runtime.ooc.cache

Subclasses of BlockKey in org.apache.sysds.runtime.ooc.cache
Modifier and Type
Class
Description
`class`
`GroupedBlockKey`
Methods in org.apache.sysds.runtime.ooc.cache that return BlockKey
Modifier and Type
Method
Description
`BlockKey`
OOCCacheManager.CachedGroupCallback.`getBlockKey()`
`BlockKey`
OOCCacheManager.CachedQueueCallback.`getBlockKey()`
`BlockKey`
BlockEntry.`getKey()`
Methods in org.apache.sysds.runtime.ooc.cache with parameters of type BlockKey
Modifier and Type
Method
Description
`int`
BlockKey.`compareTo(@NotNull BlockKey blockKey)`
`int`
OOCCache.`dereference(BlockKey key)`
Dereferencing allows an entry to be forgotten if no further reference is held.
`int`
OOCCacheImpl.`dereference(BlockKey key)`
`static void`
OOCCacheManager.`forget(BlockKey key)`
`static OOCCacheScheduler.HandoverHandle`
OOCCacheManager.`handover(BlockKey key, InMemoryQueueCallback callback)`
`default OOCFuture<BlockEntry>`
OOCCache.`pin(BlockKey key, MemoryAllowance allowance)`
Pins an item backed by an allowance.
`default OOCFuture<BlockEntry>`
OOCCache.`pinAdmitted(BlockKey key, MemoryAllowance allowance)`
Pins an item backed by an allowance.
`static void`
OOCCacheManager.`prioritize(BlockKey key, int priority)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPinRaw(BlockKey key, Object data, long size)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`putAndPinRawSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
`default BlockEntry`
OOCCache.`putPinned(BlockKey key, Object data, long size, MemoryAllowance allowance)`
Adds a new pinned entry whose bytes are already owned by the given allowance.
`static void`
OOCCacheManager.`putRaw(BlockKey key, Object data, long size)`
`static void`
OOCCacheManager.`putRawSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
`static CompletableFuture<OOCStream.QueueCallback<IndexedMatrixValue>>`
OOCCacheManager.`requestBlock(BlockKey key)`
`static OOCStream.QueueCallback<IndexedMatrixValue>`
OOCCacheManager.`tryRequestBlock(BlockKey key)`
Method parameters in org.apache.sysds.runtime.ooc.cache with type arguments of type BlockKey
Modifier and Type
Method
Description
`static CompletableFuture<List<OOCStream.QueueCallback<IndexedMatrixValue>>>`
OOCCacheManager.`requestAnyOf(List<BlockKey> keys, int n, List<BlockKey> sel)`
`static CompletableFuture<List<OOCStream.QueueCallback<IndexedMatrixValue>>>`
OOCCacheManager.`requestManyBlocks(List<BlockKey> keys)`
`static List<OOCStream.QueueCallback<IndexedMatrixValue>>`
OOCCacheManager.`tryRequestManyBlocks(List<BlockKey> keys)`
Constructors in org.apache.sysds.runtime.ooc.cache with parameters of type BlockKey
Modifier
Constructor
Description
``
`BlockEntry(BlockKey key)`
``
`BlockEntry(BlockKey key, long size, Object data)`
``
`BlockEntry(BlockKey key, long size, Object data, BlockState state)`

## Uses of BlockKey in org.apache.sysds.runtime.ooc.cache.io

Methods in org.apache.sysds.runtime.ooc.cache.io with parameters of type BlockKey
Modifier and Type
Method
Description
`void`
OOCIOHandler.`prioritizeRead(BlockKey key, double priority)`
Increase priority for a pending scheduled read if it has not started yet.
`void`
OOCMatrixIOHandler.`prioritizeRead(BlockKey key, double priority)`
`void`
OOCIOHandler.`registerSourceLocation(BlockKey key, OOCIOHandler.SourceBlockDescriptor descriptor)`
Registers the source location of a block for future direct reads.
`void`
OOCMatrixIOHandler.`registerSourceLocation(BlockKey key, OOCIOHandler.SourceBlockDescriptor descriptor)`

## Uses of BlockKey in org.apache.sysds.runtime.ooc.cache.legacy

Methods in org.apache.sysds.runtime.ooc.cache.legacy that return BlockKey
Modifier and Type
Method
Description
`BlockKey`
OOCCacheScheduler.HandoverHandle.`getKey()`
`BlockKey`
OOCCacheScheduler.`put(BlockKey key, Object data, long size)`
Places a new block in the cache.
`BlockKey`
OOCLRUCacheScheduler.`put(BlockKey key, Object data, long size)`
Methods in org.apache.sysds.runtime.ooc.cache.legacy with parameters of type BlockKey
Modifier and Type
Method
Description
`void`
OOCCacheScheduler.`addReference(BlockKey key)`
Notifies the cache that there is another reference to the same block key.
`void`
OOCLRUCacheScheduler.`addReference(BlockKey key)`
`void`
OOCCacheScheduler.`forget(BlockKey key)`
Forgets a block from the cache.
`void`
OOCLRUCacheScheduler.`forget(BlockKey key)`
`OOCCacheScheduler.HandoverHandle`
OOCCacheScheduler.`handover(BlockKey key, InMemoryQueueCallback callback)`
`OOCCacheScheduler.HandoverHandle`
OOCLRUCacheScheduler.`handover(BlockKey key, InMemoryQueueCallback callback)`
`void`
OOCCacheScheduler.`prioritize(BlockKey key, double priority)`
Adds the given priority to any pending request accessing the key.
`void`
OOCLRUCacheScheduler.`prioritize(BlockKey key, double priority)`
`BlockKey`
OOCCacheScheduler.`put(BlockKey key, Object data, long size)`
Places a new block in the cache.
`BlockKey`
OOCLRUCacheScheduler.`put(BlockKey key, Object data, long size)`
`BlockEntry`
OOCCacheScheduler.`putAndPin(BlockKey key, Object data, long size)`
Places a new block in the cache and returns a pinned handle.
`BlockEntry`
OOCLRUCacheScheduler.`putAndPin(BlockKey key, Object data, long size)`
`BlockEntry`
OOCCacheScheduler.`putAndPinSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
Places a new source-backed block in the cache and returns a pinned handle.
`BlockEntry`
OOCLRUCacheScheduler.`putAndPinSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
`void`
OOCCacheScheduler.`putSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
Places a new source-backed block in the cache and registers the location with the IO handler.
`void`
OOCLRUCacheScheduler.`putSourceBacked(BlockKey key, Object data, long size, OOCIOHandler.SourceBlockDescriptor descriptor)`
`CompletableFuture<BlockEntry>`
OOCCacheScheduler.`request(BlockKey key)`
Requests a single block from the cache.
`CompletableFuture<BlockEntry>`
OOCLRUCacheScheduler.`request(BlockKey key)`
`default BlockEntry`
OOCCacheScheduler.`tryRequest(BlockKey key)`
Tries to request a single block from the cache.
Method parameters in org.apache.sysds.runtime.ooc.cache.legacy with type arguments of type BlockKey
Modifier and Type
Method
Description
`CompletableFuture<List<BlockEntry>>`
OOCCacheScheduler.`request(List<BlockKey> keys)`
Requests a list of blocks from the cache that must be available at the same time.
`CompletableFuture<List<BlockEntry>>`
OOCLRUCacheScheduler.`request(List<BlockKey> keys)`
`CompletableFuture<List<BlockEntry>>`
OOCLRUCacheScheduler.`request(List<BlockKey> keys, boolean onlyIfAvailable)`
`CompletableFuture<List<BlockEntry>>`
OOCCacheScheduler.`requestAnyOf(List<BlockKey> keys, int n, List<BlockKey> selectionOut)`
Requests any n entries of the list of blocks, preferring an available item.
`CompletableFuture<List<BlockEntry>>`
OOCLRUCacheScheduler.`requestAnyOf(List<BlockKey> keys, int n, List<BlockKey> selectionOut)`
`List<BlockEntry>`
OOCCacheScheduler.`tryRequest(List<BlockKey> keys)`
Tries to request a list of blocks from the cache that must be available at the same time.
`List<BlockEntry>`
OOCLRUCacheScheduler.`tryRequest(List<BlockKey> keys)`
`List<BlockEntry>`
OOCCacheScheduler.`tryRequestAnyOf(List<BlockKey> keys, int n, List<BlockKey> selectionOut)`
Requests any n entries of the list of blocks, preferring an available item.
`List<BlockEntry>`
OOCLRUCacheScheduler.`tryRequestAnyOf(List<BlockKey> keys, int n, List<BlockKey> selectionOut)`

## Uses of BlockKey in org.apache.sysds.runtime.ooc.cache.packed

Methods in org.apache.sysds.runtime.ooc.cache.packed with parameters of type BlockKey
Modifier and Type
Method
Description
`int`
OOCPackedCache.`dereference(BlockKey key)`